module FacebookOAuth
  class Client
      
    @@token = nil
     
    def initialize(options = {})
        @client_id = options[:client_id]
        @client_secret = options[:client_secret]
        @redirect = options[:redirect]
    end
  
    def authorize_url(options = {})
        consumer.authorize_url({
            :client_id => @client_id,
            :redirect_uri => @redirect,
            :scope => options[:scope]
        })
    end
    
    def authorize(options = {})
        @@token = consumer.auth_code.get_token(
            options[:code],
            :redirect_uri => @redirect,
            :parse => :query
        )
    end
       
    def request(request_uri)
        @@token.get("https://graph.facebook.com/#{request_uri}".gsub('/\/\//', '')).body
    end
    
    private
      def consumer
          OAuth2::Client.new(
              @client_id,
              @client_secret,
              :site => 'https://graph.facebook.com',
              :authorize_url => 'https://www.facebook.com/dialog/oauth',
              :token_url => '/oauth/access_token'
         )
      end
  end
end